#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

#define BUFFLEN 0x1000
#define INLEN 4096
#define INNAME "maindat.war"
int infile;
unsigned char inbuff[INLEN],*inpoint;
int inleft=0;
long lastlen;
XImage *myimage;
unsigned char *vmem1;
#define IXSIZE 800
#define IYSIZE 640
int mapconv[256];
unsigned char *entrya,*entryb,*entryc,*entryd,*entrye,*entryf,*entryg;

unsigned short list[]=
{33,2,/*Unit Gfx: Dwarves*/
34,2,/*Unit Gfx: Goblin Sapper*/
35,2,/*Unit Gfx: Gryphon Rider*/
36,2,/*Unit Gfx: Dragon*/
37,2,/*Unit Gfx: Eye of Kilrogg*/
38,2,/*Unit Gfx: Gnomish Flying Machine*/
39,2,/*Unit Gfx: Human Transport*/
40,2,/*Unit Gfx: Orc Transport*/
41,2,/*Unit Gfx: Battleship*/
42,2,/*Unit Gfx: Juggernaught*/
43,2,/*Unit Gfx: Gnomish Submarine (summer,winter)*/
44,2,/*Unit Gfx: Giant Turtle (summer,winter)*/
45,2,/*Unit Gfx: Footman*/
46,2,/*Unit Gfx: Grunt*/
47,2,/*Unit Gfx: Peasant*/
48,2,/*Unit Gfx: Peon*/
49,2,/*Unit Gfx: Ballista*/
50,2,/*Unit Gfx: Catapult*/
51,2,/*Unit Gfx: Knight*/
52,2,/*Unit Gfx: Ogre*/
53,2,/*Unit Gfx: Archer*/
54,2,/*Unit Gfx: Axethrower*/
55,2,/*Unit Gfx: Mage*/
56,2,/*Unit Gfx: Necrolyte (WarCraft 1 character)*/
57,2,/*Unit Gfx: Cleric (WarCraft 1 character)*/
58,2,/*Unit Gfx: Death Knight*/
59,2,/*Unit Gfx: Human Tanker (empty)*/
60,2,/*Unit Gfx: Orc Tanker (empty)*/
61,2,/*Unit Gfx: Elven Destroyer*/
62,2,/*Unit Gfx: Troll Destroyer*/
63,2,/*Unit Gfx: Goblin Zepplin*/
64,2,/*Unit Gfx: Critter (summer)*/
65,2,/*Unit Gfx: Critter (wasteland)*/
66,2,/*Unit Gfx: Critter (winter)*/
69,2,/*Unit Gfx: Skeleton*/
70,2,/*Unit Gfx: Daemon*/
80,2,/*Building Gfx: Human Guard Tower (summer)*/
81,2,/*Building Gfx: Orc Guard Tower (summer)*/
82,2,/*Building Gfx: Human Cannon Tower (summer)*/
83,2,/*Building Gfx: Orc Cannon Tower (summer)*/
84,2,/*Building Gfx: Mage Tower (summer)*/
85,2,/*Building Gfx: Temple of the Damned (summer)*/
86,2,/*Building Gfx: Keep (summer)*/
87,2,/*Building Gfx: Stronghold (summer)*/
88,2,/*Building Gfx: Gryphon Aviary (summer)*/
89,2,/*Building Gfx: Dragon Roost (summer)*/
90,2,/*Building Gfx: Gnomish Inventor (summer)*/
91,2,/*Building Gfx: Goblin Alchemist (summer)*/
92,2,/*Building Gfx: Farm (summer)*/
93,2,/*Building Gfx: Pig Farm (summer)*/
94,2,/*Building Gfx: Human Barracks (summer)*/
95,2,/*Building Gfx: Orc Barracks (summer)*/
96,2,/*Building Gfx: Church (summer)*/
97,2,/*Building Gfx: Altar of Storms (summer)*/
98,2,/*Building Gfx: Human Scout Tower (summer)*/
99,2,/*Building Gfx: Orc Scout Tower (summer)*/
100,2,/*Building Gfx: Town Hall (summer)*/
101,2,/*Building Gfx: Great Hall (summer)*/
102,2,/*Building Gfx: Elven Lumber Mill (summer)*/
103,2,/*Building Gfx: Troll Lumber Mill (summer)*/
104,2,/*Building Gfx: Stables (summer)*/
105,2,/*Building Gfx: Ogre Mound (summer)*/
106,2,/*Building Gfx: Human Blacksmith (summer)*/
107,2,/*Building Gfx: Orc Blacksmith (summer)*/
108,2,/*Building Gfx: Human Shipyard (summer)*/
109,2,/*Building Gfx: Orc Shipyard (summer)*/
110,2,/*Building Gfx: Human Foundry (summer)*/
111,2,/*Building Gfx: Orc Foundry (summer)*/
112,2,/*Building Gfx: Human Refinery (summer)*/
113,2,/*Building Gfx: Orc Refinery (summer)*/
114,2,/*Building Gfx: Human Oil Well (summer)*/
115,2,/*Building Gfx: Orc Oil Well (summer)*/
116,2,/*Building Gfx: Castle (summer)*/
117,2,/*Building Gfx: Fortress (summer)*/
118,2,/*Building Gfx: Oil Patch (summer)*/
119,2,/*Building Gfx: Gold Mine (summer)*/
120,2,/*Unit Gfx: Corpses*/
121,2,/*Building Gfx: Destroyed site (summer)*/
122,2,/*Unit Gfx: Peasant with wood*/
123,2,/*Unit Gfx: Peon with wood*/
124,2,/*Unit Gfx: Peasant with gold*/
125,2,/*Unit Gfx: Peon with gold*/
126,2,/*Unit Gfx: Human Tanker (full)*/
127,2,/*Unit Gfx: Orc Tanker (full)*/
128,18,/*Building Gfx: Keep (winter)*/
129,18,/*Building Gfx: Stronghold (winter)*/
130,18,/*Building Gfx: Gryphon Aviary (winter)*/
131,18,/*Building Gfx: Dragon Roost (winter)*/
132,18,/*Building Gfx: Gnomish Inventor (winter)*/
133,18,/*Building Gfx: Goblin Alchemist (winter)*/
134,18,/*Building Gfx: Farm (winter)*/
135,18,/*Building Gfx: Pig Farm (winter)*/
136,18,/*Building Gfx: Human Barracks (winter)*/
137,18,/*Building Gfx: Orc Barracks (winter)*/
138,18,/*Building Gfx: Church (winter)*/
139,18,/*Building Gfx: Altar of Storms (winter)*/
140,18,/*Building Gfx: Human Scout Tower (winter)*/
141,18,/*Building Gfx: Orc Scout Tower (winter)*/
142,18,/*Building Gfx: Town Hall (winter)*/
143,18,/*Building Gfx: Great Hall (winter)*/
144,18,/*Building Gfx: Elven Lumber Mill (winter)*/
145,18,/*Building Gfx: Troll Lumber Mill (winter)*/
146,18,/*Building Gfx: Stables (winter)*/
147,18,/*Building Gfx: Ogre Mound (winter)*/
148,18,/*Building Gfx: Human Blacksmith (winter)*/
149,18,/*Building Gfx: Orc Blacksmith (winter)*/
150,18,/*Building Gfx: Human Shipyard (winter)*/
151,18,/*Building Gfx: Orc Shipyard (winter)*/
152,18,/*Building Gfx: Human Foundry (winter)*/
153,18,/*Building Gfx: Orc Foundry (winter)*/
154,18,/*Building Gfx: Human Refinery (winter)*/
155,18,/*Building Gfx: Orc Refinery (winter)*/
156,18,/*Building Gfx: Human Oil Well (winter)*/
157,18,/*Building Gfx: Orc Oil Well (winter)*/
158,18,/*Building Gfx: Castle (winter)*/
159,18,/*Building Gfx: Fortress (winter)*/
160,18,/*Building Gfx: Mage Tower (winter)*/
161,18,/*Building Gfx: Temple of the Damned (winter)*/
162,18,/*Building Gfx: Gold Mine (winter)*/
163,18,/*Building Gfx: Destroyed site (winter)*/
164,2,/*Building Gfx: X (Human player startpoint)*/
165,2,/*Building Gfx: O (Orc player startpoint)*/
166,2,/*Building Gfx: Circle of Power*/
167,2,/*Building Gfx: Dark Portal (summer)*/
168,2,/*Building Gfx: Wall (summer)*/
169,18,/*Building Gfx: Human Guard Tower (winter)*/
170,18,/*Building Gfx: Orc Guard Tower (winter)*/
171,18,/*Building Gfx: Human Cannon Tower (winter)*/
172,18,/*Building Gfx: Orc Cannon Tower (winter)*/
173,10,/*Building Gfx: Farm (wasteland)*/
174,10,/*Building Gfx: Pig Farm (wasteland)*/
175,10,/*Building Gfx: Elven Lumer Mill (wasteland)*/
176,10,/*Building Gfx: Troll Lumber Mill (wasteland)*/
177,10,/*Building Gfx: Human Oil Well (wasteland)*/
178,10,/*Building Gfx: Orc Oil Well (wasteland)*/
179,10,/*Building Gfx: Gold Mine (wasteland)*/
180,10,/*Building Gfx: Oil Patch (wasteland)*/
181,2,/*Building Gfx: Runestone (summer,wasteland)*/
182,10,/*Unit Gfx: Gnomish Submarine (wasteland)*/
183,10,/*Unit Gfx: Giant Turtle (wasteland)*/
184,18,/*Building Gfx: Dark Portal (winter)*/
185,10,/*Building Gfx: Dark Portal (wasteland)*/
186,18,/*Building Gfx: Runestone (winter)*/
187,2,/*Symbol Gfx: Gold,Wood,Oil,Mana*/
188,2,/*Building Gfx: Destroyed site (summer)*/
189,2,/*Building Gfx: Small destroyed site (summer)*/
190,18,/*Building Gfx: Small destroyed site  (winter)*/
191,10,/*Building Gfx: Small destroyed site  (wasteland)*/
324,2,/*Missile Gfx: Lightning*/
325,2,/*Missile Gfx: Gryphon Hammer*/
326,2,/*Missile Gfx: Fireball (also Dragon Breath)*/
327,2,/*Missile Gfx: Fireball (when casting FlameShield)*/
328,2,/*Missile Gfx: Flame Shield*/
329,2,/*Missile Gfx: Blizzard*/
330,2,/*Missile Gfx: Death and Decay*/
331,2,/*Missile Gfx: Big Cannon*/
332,2,/*Missile Gfx: Exorcism*/
333,2,/*Missile Gfx: Heal Effect*/
334,2,/*Missile Gfx: Touch of Death*/
335,2,/*Missile Gfx: Rune*/
336,2,/*Missile Gfx: Tornado*/
337,2,/*Missile Gfx: Catapult rock*/
338,2,/*Missile Gfx: Ballista bolt*/
339,2,/*Missile Gfx: Arrow*/
340,2,/*Missile Gfx: Axe*/
341,2,/*Missile Gfx: Submarine missile*/
342,2,/*Missile Gfx: Turtle missile*/
343,2,/*Missile Gfx: Small fire*/
344,2,/*Missile Gfx: Big fire*/
345,2,/*Missile Gfx: Ballista/Catapult impact*/
346,2,/*Missile Gfx: Normal spell*/
347,2,/*Missile Gfx: Explosion*/
348,2,/*Missile Gfx: Cannon*/
349,2,/*Missile Gfx: Cannon explosion*/
350,2,/*Missile Gfx: Cannon-Tower explosion*/
351,2,/*Missile Gfx: Daemon fire*/
352,2,/*Missile Gfx: Green cross*/
353,2,/*Missile Gfx: Unit shadow*/
356,2,/*Icons Gfx (summer)*/
357,18,/*Icons Gfx (winter)*/
358,10,/*Icons Gfx (wasteland)*/
255,
};

initci() {inleft=0;}
ci()
{
	if(!inleft)
	{
		inleft=read(infile,inbuff,INLEN);
		inpoint=inbuff;
	}
	if(!inleft) return -1;
	--inleft;
	return *inpoint++;
}

long readlong()
{
unsigned char buff[4];
	read(infile,buff,4);
	return buff[0] | (buff[1]<<8) | (buff[2]<<16) | (buff[3]<<24);
}


void decompress(int sourcelen,char *dest)
{

	unsigned int flags, b1pos, b2pos, got, len, where, i;
	unsigned char Buf1[BUFFLEN];

	for(i=0; i < BUFFLEN; i++) Buf1[i] = 0;
	b1pos = flags = 0;

	/* start the input cache */

	initci();


	while(sourcelen)
	{

		flags >>= 1;

		if(flags<256)
		{
			flags = 0x8000 | ci();--sourcelen;
		}

		if(!sourcelen) continue;

		if(flags & 1)		/* uncompressed byte */
		{
			*dest++=Buf1[b1pos++] = ci();--sourcelen;
			b1pos&=BUFFLEN-1;
		} else		/* pos/len pair */
		{
			where = ci();--sourcelen;

			if(!sourcelen) continue;

			len = ci();--sourcelen;

			where = (((len & 0x0F) << 8) | where);
			len = ((len & 0xF0) >> 4) + 3 + where;

			for(i=where; i < len; i++)
			{
				*dest++=Buf1[b1pos++] = Buf1[i & (BUFFLEN-1)];
				b1pos &=BUFFLEN-1;
			}
		}
	}
}
char *get(int item)
{
long index1,index2,length,first4;
char *dest;

	lseek(infile,(item<<2)+8,0);
	index1=readlong();
	index2=readlong();
	length=index2-index1-4;
	lseek(infile,index1,0);
	first4=readlong();
	lastlen=first4 & 0xffffff;
	dest=malloc(lastlen);
	if(dest)
	{
		if(first4 != lastlen)
			decompress(length,dest);
		else
			read(infile,dest,first4);
	}
	return dest;
}

hexout(unsigned char *where,int len)
{
long off=0;
int i,j;
unsigned char buff[16],ch;
	while(len)
	{
		printf("%06lx ",off);
		off+=16;
		j=len>16 ? 16 : len;
		len-=j;
		for(i=0;i<j;i++)
			printf(" %02x",buff[i]=*where++);
		for(;i<16;i++)
			printf("   ");
		printf("  ");
		for(i=0;i<j;i++)
		{
			ch=buff[i]&0x7f;
			if(ch<0x20) ch='.';
			putchar(ch);
		}
		printf("\n");
	}
}

#define NORMAL 0
#define INVERSE 1
#define COMCOLOR 2
#define COMCOLOR2 3
#define CURSOR 4
#define COMCURSOR 5

GC whitegc,redgc,blackgc,bluegc,greygc;
Display *dp;
Window wi;
XEvent event;
int fontbase,fontxsize,fontysize;
int xpsize,ypsize,xsize,ysize;
int screen;
char exitflag;

GC fronts[8],backs[8];

doresize(XConfigureEvent *ev)
{
	xpsize=ev->width;
	ypsize=ev->height;
	XClearWindow(dp,wi);
	ypsize-=ypsize%fontysize;
	xsize=xpsize/fontxsize;
	ysize=ypsize/fontysize;
	copyup();
}

doexpose(XExposeEvent *ev)
{
	copyup();
}


int cnum=0;
int carray=0;
int mode=0;
int tilesets[]={2,10,18,438};
handlemode(int newmode)
{
	if(newmode>=0)
	{
		mode=newmode;
		switch(mode)
		{
		case 1:
		case 2:
		case 3:
			pick(tilesets[mode-1]);
			break;
		}
	}
	switch(mode)
	{
	case 0:
		display();
		break;
	case 1:
	case 2:
	case 3:
		putarray();
		break;
	}
	copyup();
}
handledec()
{
	switch(mode)
	{
	case 0:
		if(cnum) {--cnum;handlemode(-1);}
		break;
	case 1:
	case 2:
	case 3:
		if(carray) {--carray;handlemode(-1);}
		break;
	}
}
handleinc()
{
	switch(mode)
	{
	case 0:
		if(list[cnum+cnum+2]!=255) {++cnum;handlemode(-1);}
		break;
	case 1:
	case 2:
	case 3:
		++carray;handlemode(-1);
		break;
	}
}
processkey(val)
{
	if(val==XK_Escape) exitflag=1;
	if(val==XK_Left) handledec();
	if(val==XK_Right) handleinc();
	if(val==XK_0) handlemode(0);
	if(val==XK_1) handlemode(1);
	if(val==XK_2) handlemode(2);
	if(val==XK_3) handlemode(3);
}


cattr(int offsetx,int offsety, int attr,int ch)
{
int x,y;
GC gc1,gc2;
char ch2;

	ch2=ch;
	x=offsetx*fontxsize;
	y=offsety*fontysize;
	gc1=fronts[attr];
	gc2=backs[attr];

	XFillRectangle(dp,wi,gc2,x,y,fontxsize,fontysize);
	XDrawString(dp,wi,gc1,x,y+fontbase,&ch2,1);

}

dscr(int x,int y,int w,int h)
{
	x*=fontxsize;
	y*=fontysize;
	w*=fontxsize;
	h*=fontysize;

	XCopyArea(dp,wi,wi,whitegc,x,y,w,h,x,y+fontysize);
}
uscr(int x,int y,int w,int h)
{
	x*=fontxsize;
	y*=fontysize;
	w*=fontxsize;
	h*=fontysize;

	XCopyArea(dp,wi,wi,whitegc,x,y+fontysize,w,h,x,y);
}
blank(int startx,int starty,int num)
{
int x,y;
	x=startx*fontxsize;
	y=starty*fontysize;
	XFillRectangle(dp,wi,blackgc,x,y,fontxsize*num,fontysize);
}

put(char *where,int startx,int starty,int num,int vid)
{
int x,y;
GC gc1,gc2;

	x=startx*fontxsize;
	y=starty*fontysize;
	gc1=fronts[vid];
	gc2=backs[vid];

	XFillRectangle(dp,wi,gc2,x,y,fontxsize*num,fontysize);
	XDrawString(dp,wi,gc1,x,y+fontbase,where,num);

}



getcolor(char *name)
{
XColor color1,color2;
Colormap cmap;

	cmap=DefaultColormap(dp,screen);
	if(!XAllocNamedColor(dp,cmap,name,&color1,&color2))
	{
		printf("Couldn't allocate color %s\n",name);
		exit(4);
	}
	return color1.pixel;
}



openx()
{
Font font;
char str[64];
XFontStruct *afont;

	dp=XOpenDisplay(0);
	if(!dp)
	{
		printf("Cannot open display\n");
		exit(1);
	}
	screen=XDefaultScreen(dp);
	wi=XCreateSimpleWindow(dp,RootWindow(dp,screen),20,20,IXSIZE,IYSIZE,0,0,0);
	XMapWindow(dp,wi);
	XSelectInput(dp,wi,KeyPressMask | StructureNotifyMask | ExposureMask);
	getgcs();

/*	font=XLoadFont(dp,"-schumacher-clean-bold-r-normal--8-80-75-75-c-80-*iso*");
	if(!font) printf("Font error\n");
	XSetFont(dp,whitegc,font);*/
	vmem1=malloc(IXSIZE*IYSIZE*4);
	myimage=XCreateImage(dp,DefaultVisual(dp,screen),DefaultDepth(dp,screen),ZPixmap,0,vmem1,IXSIZE,IYSIZE,8,0);

	afont=XQueryFont(dp,XGContextFromGC(whitegc));
	fontbase=afont->ascent;
	fontysize=afont->ascent+afont->descent;

	xpsize=IXSIZE;
	ypsize=IYSIZE-IYSIZE%fontysize;
	fontxsize=6;
	xsize=xpsize/fontxsize;
	ysize=ypsize/fontysize;

}
getgcs()
{
	whitegc=XCreateGC(dp,wi,0,NULL);
	blackgc=XCreateGC(dp,wi,0,NULL);
	redgc=XCreateGC(dp,wi,0,NULL);
	greygc=XCreateGC(dp,wi,0,NULL);
	bluegc=XCreateGC(dp,wi,0,NULL);
	XSetForeground(dp,whitegc,getcolor("white"));
	XSetForeground(dp,blackgc,getcolor("black"));
	XSetForeground(dp,redgc,getcolor("red"));
	XSetForeground(dp,bluegc,getcolor("blue"));
	XSetForeground(dp,greygc,getcolor("grey64"));
	fronts[NORMAL]=whitegc;
	backs[NORMAL]=blackgc;
	fronts[COMCOLOR]=blackgc;
	backs[COMCOLOR]=greygc;
	fronts[COMCOLOR2]=blackgc;
	backs[COMCOLOR2]=bluegc;
	fronts[CURSOR]=blackgc;
	backs[CURSOR]=redgc;
	fronts[COMCURSOR]=blackgc;
	backs[COMCURSOR]=redgc;
}
freegcs()
{
	XFreeGC(dp,whitegc);
	XFreeGC(dp,bluegc);
	XFreeGC(dp,greygc);
	XFreeGC(dp,blackgc);
	XFreeGC(dp,redgc);
}


closex()
{
	XDestroyWindow(dp,wi);
	XCloseDisplay(dp);
}

copyup()
{
	XPutImage(dp,wi,whitegc,myimage,0,0,0,0,IXSIZE,IYSIZE);
}

int currentmap=-1;
nloadmap(int which)
{
unsigned char *map;
	if(which==currentmap) return;
	currentmap=which;
	map=get(which);
	loadmap(map);
	free(map);
}
loadmap(char *p)
{
XColor ac;
int i,res;
Colormap cmap;
	cmap=DefaultColormap(dp,screen);
	p+=3;
	ac.green=0x3000;
	ac.blue=0;
	ac.red=0x6000;
	XAllocColor(dp,cmap,&ac);
	mapconv[0]=ac.pixel;
	for(i=1;i<256;i++)
	{
		ac.red=(*p++)<<10;
		ac.green=(*p++)<<10;
		ac.blue=(*p++)<<10;
		res=XAllocColor(dp,cmap,&ac);
		mapconv[i]=ac.pixel;
	}
}
#define pixel(x,y,c) XPutPixel(myimage,x,y,mapconv[c])


puticon(unsigned char *data,int icon,int putx,int puty)
{
int i,j,k;
int xdisp,ydisp,width,height;
long offset;
unsigned char *info,*line,*lines,ch,ch2;
	info=data+(icon<<3)+6;
	xdisp=*info++;
	ydisp=*info++;
	width=*info++;
	height=*info++;
	offset=info[0] | (info[1]<<8) | (info[2]<<16);
	lines=info=data+offset;
	for(j=0;j<height;j++)
	{
		line=info+lines[0]+(lines[1]<<8);
		lines+=2;
		i=0;
		while(i<width)
		{
			ch=*line++;
			switch(ch>>6)
			{
			case 0:
				ch&=0x3f;
				while(ch--)
					pixel(putx+xdisp+i++,puty+ydisp+j,*line++);
				break;
			case 1:
				ch&=0x3f;
				ch2=*line++;
				while(ch--)
					pixel(putx+xdisp+i++,puty+ydisp+j,ch2);
				break;
			default:
				ch&=0x7f;
				while(ch--)
					i++;
/*					pixel(putx+xdisp+i++,puty+ydisp+j,0);*/

			}
		}
	}
}

display()
{
unsigned char *data;
int xsize,ysize,num;
int x,y,count;

	nloadmap(list[cnum+cnum+1]);
	data=get(list[cnum+cnum]);
	num=data[0] | (data[1]<<8);
	xsize=data[2] | (data[3]<<8);
	ysize=data[4] | (data[5]<<8);

	x=y=count=0;
	clear();
	while(num--)
	{
		puticon(data,count,x,y);
		x+=xsize;
		if(x>IXSIZE-xsize)
		{
			x=0;
			y+=ysize;
		}
		count++;
	}
	free(data);
	copyup();
}
clear()
{
int i,j;
int c;
	c=mapconv[0];
	for(j=0;j<IYSIZE;j++)
		for(i=0;i<IXSIZE;i++)
			XPutPixel(myimage,i,j,c);
}

tryfree(char *where)
{
	if(where) free(where);
}
pick(int num)
{
	tryfree(entrya);
	tryfree(entryb);
	tryfree(entryc);
	tryfree(entryd);
	tryfree(entrye);
	tryfree(entryf);
	tryfree(entryg);
	entrya=get(num);
	entryb=get(num+1);
	entryc=get(num+2);
	entryd=get(num+3);
/*	entrye=get(num+4);
	entryf=get(num+5);
	entryg=get(num+6);*/
	loadmap(entrya);
}
minitile(int x,int y,int num)
{
int i,j;
char flip;
unsigned char *p1;
int flipx,flipy;

	flip=num&3;
	num^=flip;
	p1=entryc+(num<<4);
	flipx=flip&2 ? 7 : 0;
	flipy=flip&1 ? 7 : 0;

	for(j=0;j<8;j++)
	{
		for(i=0;i<8;i++)
		{
			pixel(x+(i^flipx),y+(j^flipy),*p1++);
		}
	}

}
puttile(int x,int y,int num)
{
int i,j;
unsigned char *p1;
	p1=entryb+(num<<5);
	for(j=0;j<4;j++)
	{
		for(i=0;i<4;i++)
		{
			minitile(x,y,p1[0]|(p1[1]<<8));
			p1+=2;
			x+=8;
		}
		x-=32;
		y+=8;
	}
}
putarray()
{
int x,y,num;
unsigned char *p1;
int at;

	x=0;y=0;
	at=carray*42*(IYSIZE/32);
	p1=entryd+at;
	clear();
	while(y<=IYSIZE-32 && at<6636)
	{
		num=0;
		while(x<16*32)
		{
			puttile(x,y,p1[num]|(p1[num+1]<<8));
			num+=2;
			x+=32;
		}
		x=0;
		y+=32;
		p1+=42;
		at+=42;
	}
	copyup();
}

main(int argc,char **argv)
{
int i,j;
int ch;
char *p;
int eventtype;
char *name = INNAME;
	if(argc>1) name = argv[1];

	infile=open(name,O_RDONLY);
	if(infile<0)
	{
		printf("Couldn't open %s\n",INNAME);
		exit(1);
	}
/*	if(fork()) return;*/
	openx();

	entrya=entryb=entryc=entryd=entrye=entryf=entryg=0;
	pick(2);
	handlemode(0);

	exitflag=0;
	while(!exitflag)
	{
		XNextEvent(dp,&event);
		eventtype=event.type;
/*printf("type=%d\n",eventtype);*/
		switch(eventtype)
		{
		case KeyPress:
			processkey(XLookupKeysym((XKeyEvent *)&event,0));
			break;
		case ConfigureNotify:
			doresize((XConfigureEvent *)&event);
			break;
		case Expose:
			doexpose((XExposeEvent *)&event);
			break;
		}
	}
}
